# functional-queue

Enqueue calls to asynchronous Javascript function or method

### Install

``` sh
$ npm install functional-queue
```

### Usage
var fnqueue = require('functional-queue')

``` javascript
var obj = {
    text: 'hello',

    worker: fnqueue(function(a, b, cb){
        console.log('IN WORKER: a=', a, 'b=', b, 'this=', this);

        // do some async work and then call the callback:

        setTimeout(function(){
            cb(a + b);
        }, 2000)

    })
}

// now call the method as many times as you need - the worker will run in series processing its queue

obj.worker(1, 2, function(sum){
    console.log('CALLBACK 1: sum=', sum);
})

obj.worker(10, 20, function(sum){
    console.log('CALLBACK 2: sum=', sum);
})
```

# License (MIT)

Copyright (c) 2013 Oleksiy Krivoshey

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
